'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     DEMO ZUR MICRO - SYSTEMERWEITERUNG  EXTENSION 1    IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' by DIE HARD
'--------------------------------------------------------------------
' ERWEITERUNG: OPEN# INPUT# PRINT#
'              FILEFREE
'-----------------------------------------------------------------------
' Das Beispiel:
' Ein 4 Kanal Analogdaten-Logger mit einstellbarer Abtastrate (die Konstanten
' SAMPLESEC,SAMPLEMIN,SAMPLEHOUR bestimmen diese Zeit)und etwa 1KByte
' (verbleibendem) Speicher der fr 250 Datenstze der 4 ADCs reicht.
' Bei einer Temperaturmessung z.B. im Abstand von 1 Std. sind das immerhin
' 10 Tage.
'
' Nach dem Anlegen der Betriebsspannung beginnt die Datenaufzeichnung.
' Die Datenaufzeichnung luft bis der Speicher voll ist, oder der Taster
' gedrckt wird.
' Wenn der Taster gedrckt wird beginnt das Auslesen der Daten ber die
' serielle Schnittstelle. Damit den Daten ein Zeitpunkt zugeordnet werden
' kann wird jeder Datensatz (hier 4 AD-Werte) mit einem Zeitwert versehen.
' Aus der Abtastrate und der Sample-Nummer wird TAG-STUNDE-MINUTE-SEKUNDE
' des "TIME-STAMPS" berechnet. Der TIMESTAMP bezieht sich auf die Zeit
' nach dem Starten der Aufzeichnung.
' Sie knnen den TIMESTAMP auf die aktuelle Stunde und Minute bei Start
' der Aufzeichnung setzen, um spter die Daten den tatschlichen Tageszeiten
' zuordnen zu knnen.
' Wenn die bertragung beendet ist, knnen sie diese wiederholen (kurzer
' Tastendruck ) 
' Achten Sie darauf, dass die Betriebsspannung zwischen speichern und
' lesen nicht unterbrochen wir, da sonst beim erneuten Anlegen der Spannung
' der Speicherzyklus beginnt und Daten verloren gehen.

'-------------------------------------------------------------------------------------
' ACHTUNG:
' Als Benutzer mssen Sie selbst darauf achten, dass durch ein
' berlanges BASIC-Programm der Maschinencode auf Page 0 oder evtl. Page 1
' nicht berschrieben wird.Ebenso mssen Sie in Ihrem Programm gewhrleisten,
' dass nicht mehr Blcke als vorhanden beschrieben werden.
' Wenn Sie die PAGE1 geladen haben, ist die max. Anzahl der freien Blcke
' FILEFREE-4 , da FILEFREE davon ausgeht,dass die PAGE1 frei ist
'------------------------------------------------------------------------------------
' SIE DRFEN DIESEN TREIBER NUR LADEN, WENN DIE PAGE0/1 NICHT VON ANDEREN
' TREIBERN/SYSTEMERWEITERUNGEN, DIE SIE BENTIGEN, BELEGT IST !
' Der Treiber ist nicht fr die MICRO mit der OS-Version 2.00 geeignet
'-------------------------------------------------------------------------------------



'--------------------------
'------ I/O PORTS ---------
'--------------------------
define TASTER   port[3]
define ADC1     ad[1]
define ADC2     ad[2]
define ADC5     ad[5]
define ADC6     ad[6]
define TXDATA   port[1]
define RXDATA   port[2]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define BLOCKCOUNTER byte[1]
define BYTECOUNTER  byte[2]
define DATA         byte[3]
define BLOCKS       byte[4]
define STAMPSEC     byte[5]
define STAMPMIN     byte[6]
define STAMPHOUR    byte[7]
define STAMPDAY     byte[8]
define CARRY        byte[9]
define SAMPLELO     byte[10]
define SAMPLEHI     byte[11]
define SAVELO       byte[12]
define SAVEHI       byte[13]
define SAMPLESEC    5
define SAMPLEMIN    1
define SAMPLEHOUR   0
'BAUD 19200
'BAUD 9600


pause 50

'---------------------------------------------------


'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII       SPEICHER MIT DATEN FLLEN          IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#WRITE
SECOND=0:open# for write
BLOCKS=filefree
'PRINT "-  DATEN SPEICHERN -" ;:print BLOCKS;:print" BLOCKS a 64 Byte":pause 100
for blockcounter=1 to BLOCKS
for bytecounter=0 to 15
goto WAIT_SAMPLING
#SAVE
print# ADC1:gosub INC_SAMPLES
print# ADC2:gosub INC_SAMPLES
print# ADC5:gosub INC_SAMPLES
print# ADC6:gosub INC_SAMPLES
next
next
'-------- MEMORY IS FULL LOOP ENDLES --------------
#WAIT1
if not TASTER then goto READ
goto WAIT1

'--------------------------------------------------
'---- WAIT UNTIL IT IS TIME TO SAMLE DATA  --------
'--------------------------------------------------
#WAIT_SAMPLING
if not TASTER then goto READ
if (HOUR<>SAMPLEHOUR)or(MINUTE<>SAMPLEMIN)or (SECOND<>SAMPLESEC) then goto WAIT_SAMPLING
'if (HOUR<>SAMPLEHOUR)then goto WAIT_SAMPLING
'if (MINUTE<>SAMPLEMIN)then goto WAIT_SAMPLING
'if (SECOND<>SAMPLESEC) then goto WAIT_SAMPLING
HOUR=0:MINUTE=0:SECOND=0:goto SAVE
'--------------------------------------------------
'---    INCREMENT THE SAMPLE COUNTER            ---
'--------------------------------------------------
#INC_SAMPLES
SAMPLELO=SAMPLELO+1
if SAMPLELO=0 then SAMPLEHI=SAMPLEHI+1
SAVELO=SAMPLELO:SAVEHI=SAMPLEHI 'SAVE
return

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III              SPEICHER LESEN                 III
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#READ
SAMPLELO=SAVELO:SAMPLEHI=SAVEHI 'RESTORE FOR REPEATED READ
STAMPDAY=0:STAMPHOUR=0:STAMPMIN=0:STAMPSEC=0 'RESET TIMESTAMPP
baud 9600:open# for read
for blockcounter=1 to BLOCKS
for bytecounter=0 to 63
#READLOOP
gosub MAKE_STAMP:print STAMPDAY;":";STAMPHOUR;":";STAMPMIN;":";STAMPSEC;" ---- ";
input# DATA:print DATA;" ";:gosub DEC_SAMPLES
if (SAMPLELO or SAMPLEHI)= 0 then goto WAIT2
input# DATA:print DATA;" ";:gosub DEC_SAMPLES
if (SAMPLELO or SAMPLEHI)= 0 then goto WAIT2
input# DATA:print DATA;" ";:gosub DEC_SAMPLES
if (SAMPLELO or SAMPLEHI)= 0 then goto WAIT2
input# DATA:print DATA:gosub DEC_SAMPLES
if (SAMPLELO or SAMPLEHI)= 0 then goto WAIT2
close#
next
print"***** -R- END OF BLOCK ";:print blockcounter;:print" ********"
next
#WAIT2
if TASTER then goto WAIT2
goto READ


'--------------------------------------------------
'---    DECCREMENT THE SAMPLE COUNTER            ---
'--------------------------------------------------
#DEC_SAMPLES
SAMPLELO=SAMPLELO-1
if SAMPLELO=255 then SAMPLEHI=SAMPLEHI-1
return
'-------------------------------------------------
'----       CREATE A TIME STAMP             ------
'-------------------------------------------------
#MAKE_STAMP
'---- CALCULATING THE STAMP SECONDS --------------
STAMPSEC=STAMPSEC+SAMPLESEC
if STAMPSEC>59 then CARRY=1 else CARRY=0
if CARRY=1 then STAMPSEC=STAMPSEC-60
'---- CALCULATING THE STAMP MINUTES --------------
STAMPMIN=STAMPMIN+SAMPLEMIN+CARRY
if STAMPMIN>59 then CARRY=1 else CARRY=0
if CARRY=1 then STAMPMIN=STAMPMIN-60
'---- CALCULATING THE STAMP HOURS --------------
STAMPHOUR=STAMPHOUR+SAMPLEHOUR+CARRY
if STAMPHOUR>23 then CARRY=1 else CARRY=0
if CARRY=1 then STAMPHOUR=STAMPHOUR-24
'---- CALCULATING THE STAMP DAYS   --------------
STAMPDAY=STAMPDAY+CARRY:return




syscode "page0_ext1.s19"
