'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'-----------------------------------------------------------------------
' THEMA: DIGITALPORT 4 FREQ
'        FOR TO NEXT
'-----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)
' Die C-Control MICRO hat sechs Ports die, auch innerhalb eines Programms,
' verschiedene Funktionen erfllen.
' PORT4 kann, neben seinen anderen Funktionen als Zhler von Ereignissen,
' mit einstellbarer Torzeit, verwendet werden
'
' BEISPIELPROGRAMM:
' Dieses Beispiel liest die Systemvartiable FREQ und schaltet die LED ein,
' wenn an PORT4 eine Frequenz zwischen 1000 u. 1500 Hz anliegt.
' Der Systemvariablen FREQ kommen zwei verschiedene Bedeutungen zu.
'
' TORZEIT:
' Das Beschreiben der Variablen FREQ stellt die Torzeit ein (20 ms Schritte)
' Gleichzeitig wird  PORT5 ZWANGSWEISE ein INPUT
' z.B. FREQ=5 stellt die Torzeit auf 100ms, der Port muss dazu ein INPUT sein.
' Deaktivieren Sie den Port um die Zhlerfunktion zu ermglichen.
' DEACT FREQ_IN
'
'
' ZHLERSTAND:
' Das Lesen der Variablen liefert den whrend der letzten Torzeit erreichten
' Zhlerstand welcher der Frequenz FREQ/TORZEIT entspricht.
' z.B. IF FREQ=100 THEN GOTO x
' Die Frequenzzhlung erfolgt im Hintergrund
'
' FREQUENZBEREICH:
' Da die Systemvariable FREQ nur 1 Byte hat, knnen auch nur 255 Ereignisse
' gezhlt werden.
' Passen Sie deshalb die Torzeit an die Frequenz, die sie verarbeiten wollen, an.
' Die kleinste Torzeit ist 1 (also 20ms) und  verarbeitet Frequenzen bis 12 kHz
' Arbeiten Sie mit unbekannten Frequenzen knnen Sie eine automatische Torzeiteinstellung
' programmieren.
' Diese beginnt mit dem kleinsten Wert und vergrssert die Torzeit solange bis sich
' ein nenneswertes Zhlergebnis in FREQ einstellt.
' Die aktuelle Torzeit gibt dann zusammen mit FREQ przise Auskunft ber die
' gemessene Frequenz
'
' EINSCHRNKUNGEN
' Whrend PAUSE u. BEEP ist die Zhlung unterbrochen, wird aber nach Ablauf der
' Zeit regulr fortgesetzt.
'-----------------------------------------------------------------------------------
' Stecken Sie bitte die Jumper JP2 und JP1 (auf Position 1-2)damit die Demo korrekt
' funktioniert.
' Schliessen Sie einen Generator mit 5V Pegel an P4 auf der Steckerleiste an wenn sie die
' Funktion des Programms prfen wollen.

'--------------------------
'------ I/O PORTS ---------
'--------------------------

define LED       port[5]
define FREQ_IN   port[4]
define ADC1      ad[1]
define ADC2      ad[2]
define ADC5      ad[5]
define ADC6      ad[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------

LED=off
'--------------------------------------------------
'-----------  SHOWING FREQUENCY RANGE    ----------
'--------------------------------------------------
'SET COUNTER GATE TIME ( 20ms UNITS )AND MAKE PORT INPUT
FREQ=5 '100ms
'READ THE COUNTS AND SWITCH LED
#START
IF (FREQ > 150) or (FREQ < 100) then LED=off
IF (FREQ < 150) and (FREQ > 100) then LED=on
goto START






